// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

package frc.robot;

import edu.wpi.first.epilogue.Logged;
import edu.wpi.first.math.geometry.Pose2d;
import edu.wpi.first.wpilibj2.command.Command;
import edu.wpi.first.wpilibj2.command.Commands;
import edu.wpi.first.wpilibj2.command.button.CommandXboxController;
import frc.robot.constants.OIConstants;
import frc.robot.interfaces.IDrivetrain;
import frc.robot.subsystems.DifferentialDrivetrain;

public class RobotContainer {
  // TODO Not sure if the polymorphism will work correctly here when logging
  @Logged(name = "Drivetrain")
  private IDrivetrain drivetrain;

  private CommandXboxController driver;

  public RobotContainer() {
    drivetrain = new DifferentialDrivetrain(
      new Pose2d(), 
      true, 
      false
    );

    driver = new CommandXboxController(OIConstants.kDriverUSB);

    configureBindings();
  }

  private void configureBindings() {
    if (drivetrain instanceof DifferentialDrivetrain) {
      ((DifferentialDrivetrain) drivetrain).setDefaultCommand(
        drivetrain.drive(driver)
      );
    }
  }

  public Command getAutonomousCommand() {
    return Commands.print("No autonomous command configured");
  }
}
